/*~struct~arrow:
 * @param isVisible
 * @text Displayed?
 * @desc Is the arrow displayed?
 * Default: 
 * @default 
 
 * @param hasMovement
 * @text Movement?
 * @desc Is movement enabled?
 * Default: 
 * @default 
 *
 */

/*~struct~arrows: 
 * @param Down Arrow
 * @text Down
 * @type struct<arrow>
 * @desc Down Arrow
 * Default: maxTopRow > 0 && topRow < maxTopRow
 * @default
 *
 * @param Left Arrow
 * @text Left
 * @type struct<arrow>
 * @desc Left Arrow
 * Default: maxTopCol > 0 && topCol < maxTopCol
 * @default
 *
 * @param Right Arrow
 * @text Right
 * @type struct<arrow>
 * @desc Right Arrow
 * Default: topCol > 0
 * @default 
 *
 * @param Up Arrow
 * @text Up
 * @type struct<arrow>
 * @desc Up Arrow
 * Default: topRow > 0
 * @default 
 *
 */

/*~struct~tone:
 * @param Red 
 * @text Red 
 * @desc Red (0 - 255)  
 * @default 0
 *
 * @param Green
 * @text Green
 * @desc Green (0 - 255)  
 * @default 0
 *
 * @param Blue
 * @text Blue 
 * @desc Blue (0 - 255)  
 * @default 0
 */

/*~struct~windowSettings:
 * @param Window Name
 * @text Window Name
 * @desc Window Name 
 * Parentheses = Scene Containing Window (default ones)
 * @type select
 * @option Actor Command (Battle)
 * @value Window_ActorCommand
 * @option Battle Actor (Battle)
 * @value Window_BattleActor
 * @option Battle Enemy (Battle)
 * @value Window_BattleEnemy
 * @option Battle Item (Battle)
 * @value Window_BattleItem
 * @option Battle Log (Battle)
 * @value Window_BattleLog
 * @option Battle Skill (Battle)
 * @value Window_BattleSkill
 * @option Battle Status (Battle)
 * @value Window_BattleStatus
 * @option Choice List (Battle, Map)
 * @value Window_ChoiceList
 * @option Command (Map)
 * @value Window_Command
 * @option Debug Edit (Debug)
 * @value Window_DebugEdit
 * @option Debug Range (Debug)
 * @value Window_DebugRange
 * @option Equip Command (Equip)
 * @value Window_EquipCommand
 * @option Equip Item (Equip)
 * @value Window_EquipItem
 * @option Equip Slot (Equip)
 * @value Window_EquipSlot
 * @option Equip Status (Equip)
 * @value Window_EquipStatus
 * @option Event Item (Battle, Map)
 * @value Window_EventItem
 * @option Game End (GameEnd)
 * @value Window_GameEnd
 * @option Gold (Battle, Map, Menu, Shop)
 * @value Window_Gold
 * @option Gold [Thin] (Battle, Map, Menu, Shop)
 * @value Window_ThinGold
 * @option Help (Battle, File, Menu)
 * @value Window_Help
 * @option Item Category (Item, Shop)
 * @value Window_ItemCategory
 * @option Item List (Item)
 * @value Window_ItemList
 * @option Map Name (Map)
 * @value Window_MapName
 * @option Menu Actor (Menu)
 * @value Window_MenuActor
 * @option Menu Command (Menu)
 * @value Window_MenuCommand
 * @option Menu Status (Menu)
 * @value Window_MenuStatus
 * @option Message (Battle, Map)
 * @value Window_Message
 * @option Name Box (Map)
 * @value Window_NameBox
 * @option Name Edit (Name)
 * @value Window_NameEdit
 * @option Name Input (Name)
 * @value Window_NameInput
 * @option Number Input (Battle, Map)
 * @value Window_NumberInput
 * @option Options (Options)
 * @value Window_Options
 * @option Party Command (Battle)
 * @value Window_PartyCommand
 * @option Playtime (Battle, Map, Menu, Shop)
 * @value Window_Playtime
 * @option Save File List (File)
 * @value Window_SavefileList
 * @option Scroll Text (Battle, Map)
 * @value Window_ScrollText
 * @option Shop Buy (Shop)
 * @value Window_ShopBuy
 * @option Shop Command (Shop)
 * @value Window_ShopCommand
 * @option Shop Number (Shop)
 * @value Window_ShopNumber
 * @option Shop Sell (Shop)
 * @value Window_ShopSell
 * @option Shop Status (Shop)
 * @value Window_ShopStatus
 * @option Skill List (Skill)
 * @value Window_SkillList
 * @option Skill Status (Skill)
 * @value Window_SkillStatus
 * @option Skill Type (Skill)
 * @value Window_SkillType
 * @option Status (Status)
 * @value Window_Status
 * @option Title Command (Title)
 * @value Window_TitleCommand
 * Default: Window_Message
 * @default Window_Message
 *
 * @param Scene Name
 * @text Scene Name
 * @type select
 * @option Battle
 * @value Scene_Battle
 * @option Debug
 * @value Scene_Debug
 * @option Equip
 * @value Scene_Equip
 * @option File
 * @value Scene_File
 * @option Game End
 * @value Scene_GameEnd
 * @option Gameover
 * @value Scene_Gameover
 * @option Item
 * @value Scene_Item
 * @option Load
 * @value Scene_Load
 * @option Map
 * @value Scene_Map
 * @option Menu
 * @value Scene_Menu
 * @option Name
 * @value Scene_Name
 * @option Options
 * @value Scene_Options
 * @option Save
 * @value Scene_Save
 * @option Shop
 * @value Scene_Shop
 * @option Skill
 * @value Scene_Skill
 * @option Status
 * @value Scene_Status
 * @option Title
 * @value Scene_Title
 * @desc Scene Name
 * Default: Scene_Map
 * @default Scene_Map
 *
 * @param Image File
 * @text Image File
 * @type text
 * @desc Image File
 * Default: Window
 * @default Window
 *
 * @param Dimmed Opacity
 * @text Dimmed Opacity
 * @desc Dimmed opacity of the the windows background. (0-255) 
 * Note: This is an eval statement.
 * Default: 192
 * @default 192
 *
 * @param Tone 
 * @text Tone
 * @type struct<tone>
 * @desc Tone (Red, Green, Blue)
 * @default 
 *
 * @param Arrows
 * @text Arrows
 * @type struct<arrows>
 * @desc Arrow Settings
 * @default 
 *
 */

/*~struct~defaultWindowSetting:
 * @param Image File
 * @text Image File
 * @type text
 * @desc Image File
 * Default: CTB.WindowExMZ.skin
 * @default CTB.WindowExMZ.skin
 *
 * @param Dimmed Opacity
 * @text Dimmed Opacity
 * @desc Dimmed opacity of the the windows background. (0-255) 
 * Note: This is an eval statement.
 * Default: 
 * @default 
 *
 * @param Tone 
 * @text Tone
 * @type struct<tone>
 * @desc Tone (Red, Green, Blue)
 * @default 
 *
 */

//=============================================================================
/*:
 * @target MZ
 * @plugindesc CT_Bolt's WindowExMZ System v1.10
 * @author CT_Bolt
 *
 * @param ---Main Settings---
 * @text Main Settings
 *
 * @param Window Settings
 * @text Window Settings
 * @type struct<windowSettings>[]
 * @parent ---Main Settings---
 * @desc Window Settings
 * @default
 *
 * @param Default Window Setting
 * @text Default Window Setting
 * @type struct<defaultWindowSetting>
 * @parent ---Main Settings---
 * @desc Default Window Setting
 * @default {"Image File":"CTB.WindowExMZ.skin","Dimmed Opacity":"","Tone":""}
 *
 * @help
 *
 * CT_Bolt's WindowExMZ
 * Version 1.10
 
 * CT_Bolt
 *
 * ***************** Description **********************
 * Customizable Windows! Yay!
 *
 * ****************** How to Use **********************
 * Adjust Parameters to Suit your needs.
 * 
 * How to change an individual skin In-Game:
 *  In the Parameter "Image File" use the following:
 *   eval:CTB.WindowExMZ.customSkin(file, id)
 *
 * Parameter Setup Example:
 *   eval:CTB.WindowExMZ.customSkin("NewWindowFilename", "Window_MapMessage")
 *
 *   Then to change use the script call:
 *   CTB.WindowExMZ.customSkinValue[id] = "'filename'"
 *
 * Script Call Example:
 *   CTB.WindowExMZ.customSkinValue["Window_MapMessage"] = "'FunWindow'"
 * 
 * How to change all window skins except the ones already defined for individual skins:
 * Setup the default skin parameter via plugin manager settings
 * 
 * Then change accordingly, default script call would be:
 *   CTB.WindowExMZ.skin = *javascript*
 *
 * ****************************************************
 * History Log:
 *    v0.20 MZ Release                      (09/07/2020)
 *    v1.00 Offical Release (Updates/Fixes) (09/08/2020)
 *    v1.10 Updated (Added Feature)         (03/01/2023)
 *
 * ****************************************************
 * Terms of Use:
 *   Free to use commercial or non-commercial
 *   Credit would be nice.
 *
 *  Copyright [2020] [N. Giem] (Aka. CT_Bolt)
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */

//=============================================================================
// Parameter Variables
//=============================================================================
var CTB = CTB || {}; CTB.WindowExMZ = CTB.WindowExMZ || {}; CTB.WindowExMZ.sceneSettings = [];
var Imported = Imported || {}; Imported["CTB_WindowExMZ"] = 1.10;
CTB.WindowExMZ.customSkinValue = CTB.WindowExMZ.customSkinValue || [];
CTB.WindowExMZ.skin = null;

(($_$) => {
	// Core
	String.prototype.isJSON = function(){if (/^[\],:{}\s]*$/.test(this.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {return true;}return false;}	
    function getPluginParameters() {var a = document.currentScript || (function() { var b = document.getElementsByTagName('script'); return b[b.length - 1]; })(); return PluginManager.parameters(a.src.substring((a.src.lastIndexOf('/') + 1), a.src.indexOf('.js')));} $_$.params = getPluginParameters();
	$_$.params['Default Window Setting'] = $_$.params['Default Window Setting'] || '{}';
	$_$.params['Default Window Setting'] = JSON.parse($_$.params['Default Window Setting']);
	console.log($_$.params['Default Window Setting']);
	
	// Settings
	const tempSettings = $_$.params['Window Settings'] ? (JSON.parse($_$.params['Window Settings']) || []) : [];
	tempSettings.forEach(function(i){
		if (i.isJSON()){
			CTB.WindowExMZ.sceneSettings[JSON.parse(i)["Window Name"].replace('\r','')] = JSON.parse(i);
			CTB.WindowExMZ.sceneSettings[JSON.parse(i)["Window Name"].replace('\r','')] = CTB.WindowExMZ.sceneSettings[JSON.parse(i)["Window Name"].replace('\r','')] || {};
			CTB.WindowExMZ.sceneSettings[JSON.parse(i)["Window Name"].replace('\r','')][JSON.parse(i)["Scene Name"].replace('\r','')] = JSON.parse(i);
		}
	});
	
	//=============================================================================
	// CTB.WindowExMZ
	//=============================================================================
	
	// New
    CTB.WindowExMZ.customSkin = function(d, id){		
		d = d || "Window";
		id = String(id) || 0;
		CTB.WindowExMZ.customSkinValue = CTB.WindowExMZ.customSkinValue || [];
		return CTB.WindowExMZ.customSkinValue[id] ? eval(CTB.WindowExMZ.customSkinValue[id]) : d;
	};
	//=============================================================================
	// CTB.WindowExMZ: End
	//=============================================================================
	
	//=============================================================================
	// Game_Interpreter
	//=============================================================================
    // New
    Game_Interpreter.prototype.changeWindowskinEx = function(a, b) {
        var name = String(a || 'Window');
		$gameSystem.WindowExMZ  = $gameSystem.WindowExMZ || {};
		$gameSystem.WindowExMZ[b]=$gameSystem.WindowExMZ[b] || {};		
		if (name){
			$gameSystem.WindowExMZ[b].skinName = name;
			ImageManager.loadSystem(name);
			this.setWaitMode('image');
		}		
    };
	//=============================================================================
	// Game_Interpreter: End
	//=============================================================================
	
	//=============================================================================
	// Window
	//=============================================================================
	// Alias
	$_$['Window.prototype.initialize'] = Window.prototype.initialize;
	Window.prototype.initialize = function() {
	  $_$['Window.prototype.initialize'].apply(this, arguments);
	  this.leftArrowVisible = false;
	  this.rightArrowVisible = false;
	};


	// Alias
	$_$['Window.prototype._createAllParts'] = Window.prototype._createAllParts;
	Window.prototype._createAllParts = function() {
	  $_$['Window.prototype._createAllParts'].apply(this, arguments);
	  this._leftArrowSprite = new Sprite();
	  this._rightArrowSprite = new Sprite();
	  this._leftArrowSprite.visible = false;
	  this._rightArrowSprite.visible = false;
	  this.addChild(this._leftArrowSprite);
	  this.addChild(this._rightArrowSprite);
	  //if (!this._duh) {this._duh = true; console.log(this)};
	};

	// Alias
	$_$['Window.prototype._refreshArrows'] = Window.prototype._refreshArrows;
	Window.prototype._refreshArrows = function() {
	  $_$['Window.prototype._refreshArrows'].apply(this, arguments);

	  var w = this._width, h = this._height;
	  var p = 24;
	  var q = p / 2;
	  var sx = 96 + p, sy = p;

	  this._leftArrowSprite.bitmap = this._windowskin;
	  this._leftArrowSprite.anchor.x = 0.5;
	  this._leftArrowSprite.anchor.y = 0.5;
	  this._leftArrowSprite.setFrame(sx, sy+q, q, p);
	  this._leftArrowSprite.move(q, h/2);
	  this._rightArrowSprite.bitmap = this._windowskin;
	  this._rightArrowSprite.anchor.x = 0.5;
	  this._rightArrowSprite.anchor.y = 0.5;
	  this._rightArrowSprite.setFrame(sx+p+q, sy+q, q, p);
	  this._rightArrowSprite.move(w-q, h/2);

	  // Set Original Location
	  this._downArrowSprite.originalx = this._downArrowSprite.x;
	  this._downArrowSprite.originaly = this._downArrowSprite.y;
	  this._leftArrowSprite.originalx = this._leftArrowSprite.x;
	  this._leftArrowSprite.originaly = this._leftArrowSprite.y;
	  this._rightArrowSprite.originalx = this._rightArrowSprite.x;
	  this._rightArrowSprite.originaly = this._rightArrowSprite.y;
	  this._upArrowSprite.originalx = this._upArrowSprite.x;
	  this._upArrowSprite.originaly = this._upArrowSprite.y;

	  this._downArrowSprite.isDirStarted = false;
	  this._leftArrowSprite.isDirStarted = false;
	  this._rightArrowSprite.isDirStarted = false;
	  this._upArrowSprite.isDirStarted = false;
	};
	
	// Alias
	$_$['Window.prototype.setTone'] = Window.prototype.setTone;
	Window.prototype.setTone = function(r, g, b) {
		if (this.isItWindowExMZ("Tone")){			
			var t = JSON.parse(CTB.WindowExMZ.sceneSettings[this.constructor.name][SceneManager._scene.constructor.name]["Tone"]);
			this._colorTone = [eval(t['Red']), eval(t['Green']), eval(t['Blue']), 0] || this._colorTone;
			const tone = this._colorTone;
			this._refreshBack();
		}else if ($_$.params['Default Window Setting']['Tone']){
			var t = JSON.parse($_$.params['Default Window Setting']['Tone']);
			this._colorTone = [eval(t['Red']), eval(t['Green']), eval(t['Blue']), 0] || this._colorTone;
			const tone = this._colorTone;
			this._refreshBack();
		}else{
			$_$['Window.prototype.setTone'].apply(this, arguments);
		};
	};
	
	// New
	Window.prototype._updateSpriteMovement = function(spr, min, max, xory, mode, spd, amnt, center, startDir1) {		
		// Set Defaults
		min = min || 0;
		max = max || 0;
		spd = spd ? eval(spd) : 1;
		amnt = amnt ? eval(amnt) : 1;
		xory = xory || 'x';
		mode = mode || 'oscillation';
		center = (center === true) ? spr['original'+xory] : center || 0;
		spr[String(mode)] = spr[String(mode)] || {};
		if (startDir1 && !spr.isDirStarted) {spr[String(mode)].isDir1 = true; spr.isDirStarted = true;}
		spr[String(mode)].countAmount = spr[String(mode)].countAmount || spd;
		spr[String(mode)].count = spr[String(mode)].count || 0; spr[String(mode)].count++;
		if (spr[String(mode)].count > spr[String(mode)].countAmount) {spr[String(mode)].count = 0; spr[String(mode)].canMove = true;}
		if (spr[String(mode)].canMove){
			spr[String(mode)].canMove = false;
			if (mode.toLowerCase().includes('oscillation')){
				spr[String(mode)].isDir1 ? spr[String(xory)] = spr[String(xory)] + amnt : spr[String(xory)] = spr[String(xory)] - amnt;
				if (spr[String(xory)] <= center+min) {spr[String(mode)].isDir1 = true;};
				if (spr[String(xory)] >= center+max){spr[String(mode)].isDir1 = false;};
			};
		};
	};

	// Alias-ish
	$_$['Window.prototype.topRow'] = Window.prototype.topRow || function(){return null;};
	Window.prototype.topRow = function() {
		return $_$['Window.prototype.topRow'].apply(this, arguments);
	};
	
	// Alias-ish	
	$_$['Window.prototype.maxTopRow'] = Window.prototype.maxTopRow || function(){return null;};
	Window.prototype.maxTopRow = function() {
		return $_$['Window.prototype.maxTopRow'].apply(this, arguments);
	};

	// Alias
	$_$['Window.prototype._updateArrows'] = Window.prototype._updateArrows;
	Window.prototype._updateArrows = function() {
		$_$['Window.prototype._updateArrows'].apply(this, arguments);
		var topRow = this.topRow(), maxTopRow = this.maxTopRow();		
		const useArrows = this.isItWindowExMZ("Arrows"), win = this.constructor.name, scene = SceneManager._scene.constructor.name;
		
		if (useArrows) {
			const settings = JSON.parse(CTB.WindowExMZ.sceneSettings[win][scene]['Arrows']);
			var setting = 'Left Arrow';
			if (settings[setting])  {
				var currentSetting = eval(JSON.parse(settings[setting]));
				if (currentSetting.isVisible) {this._leftArrowSprite.visible  = eval(currentSetting.isVisible);};
				if (eval(currentSetting.hasMovement)){this._updateSpriteMovement(this._leftArrowSprite,  -4,  4, 'x', null, 2, null, true);};
			};
			
			var setting = 'Right Arrow';
			if (settings[setting])  {
				var currentSetting = eval(JSON.parse(settings[setting]));
				if (currentSetting.isVisible) {this._rightArrowSprite.visible  = eval(currentSetting.isVisible);};
				if (eval(currentSetting.hasMovement)){this._updateSpriteMovement(this._rightArrowSprite, -4,  4, 'x', null, 2, null, true, true);};
			};

			var setting = 'Down Arrow';
			if (settings[setting])  {
				var currentSetting = eval(JSON.parse(settings[setting]));
				if (currentSetting.isVisible) {this._downArrowSprite.visible  = eval(currentSetting.isVisible);};
				if (eval(currentSetting.hasMovement)){this._updateSpriteMovement(this._downArrowSprite,  -4,  4, 'y', null, 2, null, true, true);};
			};

			var setting = 'Up Arrow';
			if (settings[setting])  {
				var currentSetting = eval(JSON.parse(settings[setting]));
				if (currentSetting.isVisible) {this._upArrowSprite.visible  = eval(currentSetting.isVisible);};
				if (eval(currentSetting.hasMovement)){this._updateSpriteMovement(this._upArrowSprite,    -4,  4, 'y', null, 2, null, true);};
			};
		}
	};
	
	// New	
	Window.prototype.isItWindowExMZ = function(a) {
		if (CTB.WindowExMZ.sceneSettings[this.constructor.name]){
			if (CTB.WindowExMZ.sceneSettings[this.constructor.name] !== undefined){
				if (CTB.WindowExMZ.sceneSettings[this.constructor.name][SceneManager._scene.constructor.name]){
					if (CTB.WindowExMZ.sceneSettings[this.constructor.name][SceneManager._scene.constructor.name] !== undefined){
						if (a){
							if (CTB.WindowExMZ.sceneSettings[this.constructor.name][SceneManager._scene.constructor.name][a]){
								if (CTB.WindowExMZ.sceneSettings[this.constructor.name][SceneManager._scene.constructor.name][a] !== undefined) {						
									return true;						
								};
							};
						}else{
							return true;
						};
					};
				};
			};
		};
		return false;
	};
	//=============================================================================
	// Window: End
	//=============================================================================

	//=============================================================================
	// Window_Base
	//=============================================================================	
    // New
	Window_Base.prototype.changeWindowskinEx = function(a) {
		var skinPropName = "Image File";

		a = a || CTB.WindowExMZ.sceneSettings[this.constructor.name][SceneManager._scene.constructor.name][skinPropName];
		$gameSystem.WindowExMZ[this.constructor.name] = $gameSystem.WindowExMZ[this.constructor.name] || {};
		$gameSystem.WindowExMZ[this.constructor.name][SceneManager._scene.constructor.name] = $gameSystem.WindowExMZ[this.constructor.name][SceneManager._scene.constructor.name] || {};
		$gameSystem.WindowExMZ[this.constructor.name][SceneManager._scene.constructor.name].skinName = a;
		if ($gameSystem.WindowExMZ[this.constructor.name][SceneManager._scene.constructor.name].skinName) {
			if (this._windowskinName[this.constructor.name][SceneManager._scene.constructor.name] !== $gameSystem.WindowExMZ[this.constructor.name][SceneManager._scene.constructor.name].skinName) {
				this.loadWindowskinEx($gameSystem.WindowExMZ[this.constructor.name][SceneManager._scene.constructor.name].skinName);
			}
		}		
	};
	
    // New
    Window_Base.prototype.loadWindowskinEx = function(a) {
		this._windowskinName = this._windowskinName || {};
		this._windowskinName[this.constructor.name] = this._windowskinName[this.constructor.name] || {};
		this._windowskinName[this.constructor.name][SceneManager._scene.constructor.name] = this._windowskinName[this.constructor.name][SceneManager._scene.constructor.name] || {};
		
        this._windowskinName[this.constructor.name][SceneManager._scene.constructor.name] = a || $gameSystem.WindowExMZ[this.constructor.name][SceneManager._scene.constructor.name].skinName || 'Window';
		var i = this._windowskinName[this.constructor.name][SceneManager._scene.constructor.name];

		if (i){
			if (i.toLowerCase().startsWith('eval:')){
				i = i.replace(/eval:/i, '');	
				this._windowskinName[this.constructor.name][SceneManager._scene.constructor.name] = eval(i);
				this.windowskin = ImageManager.loadSystem(eval(i));
			}else{
				this.windowskin = ImageManager.loadSystem(i);
			}
		}
    };
	
	// New
	Window_Base.prototype.WindowExMZ_DimmedOpacity = function() {
		return eval(CTB.WindowExMZ.sceneSettings[this.constructor.name][SceneManager._scene.constructor.name]["Dimmed Opacity"]);
	};

	// Alias
	$_$['Window_Base.prototype.standardBackOpacity'] = Window_Base.prototype.standardBackOpacity;
	Window_Base.prototype.standardBackOpacity = function() {
		if (this.isItWindowExMZ("Dimmed Opacity")){
			return this.WindowExMZ_DimmedOpacity();
		}else if ($_$.params['Default Window Setting']['Dimmed Opacity']){
			let dim = eval($_$.params['Default Window Setting']['Dimmed Opacity']);
			return dim;
		};
		return $_$['Window_Base.prototype.standardBackOpacity'].apply(this, arguments);
	};

    // Alias
    $_$['Window_Base.prototype.update'] = Window_Base.prototype.update;
	Window_Base.prototype.update = function() {
		$_$['Window_Base.prototype.update'].apply(this, arguments);
		
		$gameSystem.WindowExMZ  = $gameSystem.WindowExMZ || {};
		$gameSystem.WindowExMZ[this.constructor.name] = $gameSystem.WindowExMZ[this.constructor.name] || {}
		$gameSystem.WindowExMZ[this.constructor.name][SceneManager._scene.constructor.name] = $gameSystem.WindowExMZ[this.constructor.name][SceneManager._scene.constructor.name] || {};
		
		// Window Skin
		this._windowskinName = this._windowskinName || {};
		this._windowskinName[this.constructor.name] = this._windowskinName[this.constructor.name] || {};	 	  
		this._windowskinName[this.constructor.name][SceneManager._scene.constructor.name] = this._windowskinName[this.constructor.name][SceneManager._scene.constructor.name] || {};	 	  		
		if (this.isItWindowExMZ("Image File")) {
			this.changeWindowskinEx();
		}else if ($_$.params['Default Window Setting']['Image File']){
			let skin = eval($_$.params['Default Window Setting']['Image File']);
			if (skin) {this.windowskin = ImageManager.loadSystem(skin);};
		};
    };	
	//=============================================================================
	// Window_Base: End
	//=============================================================================
	
})(CTB.WindowExMZ, this);