// ChangeWindowBackSize.js Ver.1.0.0
// MIT License (C) 2023 あわやまたな
// http://opensource.org/licenses/mit-license.php

/*:
* @target MZ MV
* @plugindesc ウィンドウ背景のサイズを変更します。
* @author あわやまたな (Awaya_Matana)
* @url https://awaya3ji.seesaa.net/article/498198895.html
* @help 
*
* [更新履歴]
* 2023/02/16：Ver.1.0.0　公開。
*
* @param padding
* @text パディング
* @type number
* @default -2
*
*/

'use strict';

{

	const pluginName = document.currentScript.src.match(/^.*\/(.*).js$/)[1];
	const parameters = PluginManager.parameters(pluginName);
	const padding = Number(parameters["padding"]);
	
	const _Window__refreshBack = Window.prototype._refreshBack;
	Window.prototype._refreshBack = function() {
		const margin = this._margin;
		this._margin += padding;
		_Window__refreshBack.call(this);
		this._margin = margin;
	};

}