var Victor = Victor || {};
Victor.killSwitch = Victor.killSwitch|| {};
//=============================================================================
// inVictor - killSwitch v1.0.0 06/02/2021
// INV - killSwitch.js
//=============================================================================
/*
TERMS of USE

·Free to use in comercial and non-comercial games, as long as you give credits to inVictor.

·Do not sell or claim authorship of this plugin wholy or partially.

·You can edit and adapt the code, as long as you still give credit. 

·Do not redistribute this plugin.

·I reserve the right to change these terms of use.

*/
var Imported = Imported || {};
Imported.killSwitch = "killSwitch";
/*:
* @target MZ
* @plugindesc Allows instantly killing all enemies by pressing a button.
* @author inVictor || Version 1.0.0
* @help
* -inVictor's Kill Switch-
*
* This is a little scriptlet that I made a couple of months back to
* help me testing. The purpose of it is to allow you as a developer (or a tester)
* to quickly dispose of all enemies in a battle by pressing a key of your choosing.
* By default, the "kill switch" will be K in your keyboard and this will only
* work during playtest (battle test included), but you can disable that in case
* you want to use it as a cheating trick for your players or to help your
* beta testers.
*
* You can also trigger the effect through the script call: 
* $gameTroop.killThemAll()
*
* @param enable
* @text Only usable during battle test?
* @type boolean
* @on Yes
* @off No
* @default true
*
* @param Kill Switch
* @desc This key toggles the markers ON/OFF. 
* Default is 75 (K)
* @type number
* @min 0
* @default 75
* @parent Keys
*/
($=> {
	
	const KillSwitchPluginName = document.currentScript.src.match(/.+\/(.+)\.js/)[1];
	const parameters = PluginManager.parameters(KillSwitchPluginName);
	const enable = JSON.parse(parameters['enable'].toLowerCase());
	const killSwitch = parameters['Kill Switch'];
	
	// Activation keys
	Input.keyMapper[killSwitch] = 'kill'; // K key

	// Kill switch
	//-----------------------------------------------------------------------------
	Game_Troop.prototype.killThemAll = function() {
		for(i = 0; i < this.members().length; i++){
			this.members()[i].die();
			this.members()[i].performCollapse();
			this.members()[i].refresh();
		}
	};

	const _Scene_Battle_update = $.update;
	$.update = function () {
		_Scene_Battle_update.call(this);
		if (Input.isTriggered('kill')){
			let condition = true;
			if (enable) condition = $gameTemp.isPlaytest();
			if (condition) $gameTroop.killThemAll();
		}
	};
	
})(Scene_Battle.prototype);