//=============================================================================
// RPG Maker MZ - Balloons
//=============================================================================

/*:
 * @target MZ
 * @plugindesc Balloons.
 * @author H
 *
 * @param speed
 * @text Balloon animation frame rate
 * @type number
 * @desc The lower the number, the higher the animation speed
 * @default 8
 *
 * @param offsets
 * @text Balloon offset
 * @type string[]
 * @desc X and Y offset of the balloons (one line for one balloon), separated with a space
 * @default []
 */

(() => {
  const { speed, ...params } = PluginManager.parameters("_Balloons");
  const offsets = JSON.parse(params.offsets);

  // Sprite_Balloon

  Sprite_Balloon.prototype.speed = function () {
    return Number(speed) || 8;
  };

  const Sprite_Balloon_updatePosition = Sprite_Balloon.prototype.updatePosition;
  Sprite_Balloon.prototype.updatePosition = function () {
    Sprite_Balloon_updatePosition.call(this);
    const offset = offsets[this._balloonId - 1] || "";
    const [x, y] = offset.split(" ");
    this.x += Number(x) || 0;
    this.y += Number(y) || 0;
  };
})();
