﻿(()=>{

Scene_Battle.prototype.createHelpWindow = function() {
    const rect = this.helpWindowRect();
    this._helpWindow = new Window_Help(rect);
    this._helpWindow.hide();
    this.addWindow(this._helpWindow);
};

Scene_Battle.prototype.helpWindowRect = function() {
    const wx = 0;
    const wy = this.helpAreaTop();
    const ww = Graphics.boxWidth;
    const wh = this.helpAreaHeight();
    return new Rectangle(wx, wy, ww, wh);
};









//-----------------------------------------------------------------------------
// Scene_Shop
//
// The scene class of the shop screen.

Scene_Shop.prototype.create = function() {
    Scene_MenuBase.prototype.create.call(this);
    this.createHelpWindow();
    this.createGoldWindow();
    this.createCommandWindow();
//    this.createDummyWindow();
    this.createNumberWindow();
    this.createStatusWindow();
    this.createBuyWindow();
    this.createCategoryWindow();
    this.createSellWindow();
};

Scene_Shop.prototype.goldWindowRect = function() {
    const ww = 200;//this.mainCommandWidth();
    const wh = 68;//this.calcWindowHeight(1, true);
    const wx = 352;//Graphics.boxWidth - ww;
    const wy = 16;//this.mainAreaTop();
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Shop.prototype.createCommandWindow = function() {
    const rect = this.commandWindowRect();
    this._commandWindow = new Window_ShopCommand(rect);
    this._commandWindow.setPurchaseOnly(this._purchaseOnly);
//    this._commandWindow.y = this.mainAreaTop();
    this._commandWindow.setHandler("buy", this.commandBuy.bind(this));
    this._commandWindow.setHandler("sell", this.commandSell.bind(this));
    this._commandWindow.setHandler("cancel", this.popScene.bind(this));
    this.addWindow(this._commandWindow);
};

Scene_Shop.prototype.commandWindowRect = function() {
    const wx = 552;
    const wy = 423;//this.mainAreaTop();
    const ww = 392;//this._goldWindow.x;
    const wh = this.calcWindowHeight(1, true);
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Shop.prototype.numberWindowRect = function() {
    const wx = 152;
    const wy = 91;//this._dummyWindow.y;
    const ww = 400;//Graphics.boxWidth - this.statusWidth();
    const wh = 400;//this._dummyWindow.height;
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Shop.prototype.statusWindowRect = function() {
    const ww = 200;//this.statusWidth();
    const wh = 68;//this._dummyWindow.height;
    const wx = 152;//Graphics.boxWidth - ww;
    const wy = 16;//this._dummyWindow.y;
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Shop.prototype.buyWindowRect = function() {
    const wx = 152;
    const wy = 91;//this._dummyWindow.y;
    const ww = 400;//Graphics.boxWidth - this.statusWidth();
    const wh = 400;//this._dummyWindow.height;
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Shop.prototype.categoryWindowRect = function() {
    const wx = 0;
    const wy = 94;//this._dummyWindow.y;
    const ww = Graphics.boxWidth;
    const wh = this.calcWindowHeight(1, true);
    return new Rectangle(wx, wy, ww, wh);
};


Scene_Shop.prototype.sellWindowRect = function() {
    const wx = 152;
    const wy = this._categoryWindow.y + this._categoryWindow.height - 3;
    const ww = 400;//Graphics.boxWidth;
    const wh = 
        this.mainAreaHeight() -
        this._commandWindow.height -
        this._categoryWindow.height;
    return new Rectangle(wx, wy, ww, wh);
};
Window_ShopSell.prototype.maxCols = function() {
    return 1;
};

Scene_Shop.prototype.commandBuy = function() {
//    this._dummyWindow.hide();
    this.activateBuyWindow();
};

Scene_Shop.prototype.commandSell = function() {
//    this._dummyWindow.hide();
    this._sellWindow.show();
    this._sellWindow.deselect();
    this._sellWindow.refresh();
    if (this._categoryWindow.needsSelection()) {
        this._categoryWindow.show();
        this._categoryWindow.activate();
    } else {
        this.onCategoryOk();
    }
};

Scene_Shop.prototype.onBuyCancel = function() {
    this._commandWindow.activate();
//    this._dummyWindow.show();
    this._buyWindow.hide();
    this._statusWindow.hide();
    this._statusWindow.setItem(null);
    this._helpWindow.clear();
};

Scene_Shop.prototype.onCategoryCancel = function() {
    this._commandWindow.activate();
//    this._dummyWindow.show();
    this._categoryWindow.hide();
    this._sellWindow.hide();
};

Scene_Shop.prototype.helpWindowRect = function() {
    const wx = 152;
    const wy = 498;//this.mainAreaTop();
    const ww = 792;//Graphics.boxWidth;
    const wh = 102;//this.calcWindowHeight(1, false);
this.backOpacity = 255;
    return new Rectangle(wx, wy, ww, wh);
};
//======================================================

Sprite_Destination.prototype.createBitmap = function() {

const tileWidth = $gameMap.tileWidth();
const tileHeight = $gameMap.tileHeight();
this.bitmap = new Bitmap(tileWidth, tileHeight);
//this.bitmap.fillAll("white");
this.anchor.x = 0.5;
this.anchor.y = 0.5;
this.blendMode = 1;
};
//=============================================================================
//=============================================================================
//Normal speed with mouse.
//=============================================================================
Game_Player.prototype.updateDashing = function() {
    if (this.isMoving()) {
        return;
    }
    if (this.canMove() && !this.isInVehicle() && !$gameMap.isDashDisabled()) {
        this._dashing = this.isDashButtonPressed();
    } else {
        this._dashing = false;
    }
};
//=============================================================================
Scene_Message.prototype.messageWindowRect = function() {
    const ww = 928;//Graphics.boxWidth;
    const wh = this.calcWindowHeight(4, false) + 8;
    const wx = 162;//(Graphics.boxWidth - ww) / 2;
    const wy = 0;
    return new Rectangle(wx, wy, ww, wh);
};
//=============================================================================
//Disable touch Ui.
//=============================================================================
//Scene_Map.prototype.createButtons = function() { };
//Scene_Battle.prototype.createButtons = function() { };
//Scene_MenuBase.prototype.createButtons = function() { };


//=============================================================================
//Disable the resizing by mouse in the game's window.
//=============================================================================
//require('nw.gui').Window.get().setResizable(false);
//=============================================================================
//Invisible buttons
//=============================================================================
Window_Selectable.prototype.drawBackgroundRect = function(rect) {

const c1 = ColorManager.itemBackColor1();

const c2 = ColorManager.itemBackColor2();

const x = rect.x;

const y = rect.y;
    const w = rect.width;

const h = rect.height;

//this.contentsBack.gradientFillRect(x, y, w, h, c1, c2, true);
    //this.contentsBack.strokeRect(x, y, w, h, c1);

};



//Window_Base.prototype.updateBackOpacity = function() {
//    this.backOpacity = 255;
//};
//-----------------------------------------------------------------------------
// Main_menu
//
Scene_Menu.prototype.commandWindowRect = function() {
    const ww = 224;//this.mainCommandWidth();
    const wh = 464;//this.mainAreaHeight();// - this.goldWindowRect().height;
    const wx = 732;//this.isRightInputMode() ? Graphics.boxWidth - ww : 0;
    const wy = 22;//this.mainAreaTop();
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Menu.prototype.goldWindowRect = function() {
    const ww = 224;//this.mainCommandWidth();
    const wh = this.calcWindowHeight(1, true);
    const wx = 732;//this.isRightInputMode() ? Graphics.boxWidth - ww : 0;
    const wy = 518;//this.mainAreaBottom() - wh;
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Menu.prototype.statusWindowRect = function() {
    const ww = 580;//Graphics.boxWidth - this.mainCommandWidth();
    const wh = this.mainAreaHeight();
    const wx = 140;//this.isRightInputMode() ? 0 : Graphics.boxWidth - ww;
    const wy = 22;//this.mainAreaTop();
    return new Rectangle(wx, wy, ww, wh);
};
//-----------------------------------------------------------------------------
// Menu_Item
//
Window_ItemCategory.prototype.maxCols = function() {
    return 2;
};

Scene_ItemBase.prototype.actorWindowRect = function() {
    const wx = 0;
    const wy = 22;//Math.min(this.mainAreaTop(), this.helpAreaTop());
    const ww = 580;//Graphics.boxWidth - this.mainCommandWidth();
    const wh = this.mainAreaHeight() + this.helpAreaHeight();
    return new Rectangle(wx, wy, ww, wh);
};
Scene_Item.prototype.categoryWindowRect = function() {
    const wx = 167;
    const wy = 42;//this.mainAreaTop();
    const ww = 762;//Graphics.boxWidth;
    const wh = this.calcWindowHeight(1, true);
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Item.prototype.itemWindowRect = function() {
    const wx = 167;
    const wy = 112;//this._categoryWindow.y + this._categoryWindow.height;
    const ww = 762;//Graphics.boxWidth;
    const wh = 340;//this.mainAreaBottom() - wy;
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Item.prototype.helpWindowRect = function() {
    const wx = 167;
    const wy = 459;//this.mainAreaTop();
    const ww = 762;//Graphics.boxWidth;
    const wh = 102;//this.calcWindowHeight(1, false);
    return new Rectangle(wx, wy, ww, wh);
};
//-----------------------------------------------------------------------------
// Menu_Skill
//
Window_SkillList.prototype.maxCols = function() {
    return 2;
};

Scene_Skill.prototype.skillTypeWindowRect = function() {
    const ww = 178;//this.mainCommandWidth();
    const wh = this.calcWindowHeight(3, true);
    const wx = 751;//this.isRightInputMode() ? Graphics.boxWidth - ww : 0;
    const wy = 44;//this.mainAreaTop();
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Skill.prototype.statusWindowRect = function() {
    const ww = 580;//Graphics.boxWidth - this.mainCommandWidth();
    const wh = this._skillTypeWindow.height;
    const wx = 167;//this.isRightInputMode() ? 0 : Graphics.boxWidth - ww;
    const wy = 44;//this.mainAreaTop();
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Skill.prototype.itemWindowRect = function() {
    const wx = 167;;
    const wy = 204;//this._statusWindow.y + this._statusWindow.height;
    const ww = 762;//Graphics.boxWidth;
    const wh = 263;//this.mainAreaHeight() - this._statusWindow.height;
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Skill.prototype.helpWindowRect = function() {
    const wx = 167;
    const wy = 471;//this.mainAreaTop();
    const ww = 762;//Graphics.boxWidth;
    const wh = 102;//this.calcWindowHeight(1, false);
    return new Rectangle(wx, wy, ww, wh);
};
//-----------------------------------------------------------------------------
// Menu_Equip
//
Window_EquipCommand.prototype.maxCols = function() {
    return 2;
};

Window_EquipCommand.prototype.makeCommandList = function() {
//    this.addCommand(TextManager.equip2, "equip");
    this.addCommand(TextManager.optimize, "optimize");
    this.addCommand(TextManager.clear, "clear");
};
Scene_Equip.prototype.statusWindowRect = function() {
    const wx = 167;
    const wy = 29;//this.mainAreaTop();
    const ww = this.statusWidth();
    const wh = this.mainAreaHeight();
    return new Rectangle(wx, wy, ww, wh);
};
Scene_Equip.prototype.createCommandWindow = function() {
    const rect = this.commandWindowRect();
    this._commandWindow = new Window_EquipCommand(rect);
    this._commandWindow.setHelpWindow(this._helpWindow);
//    this._commandWindow.setHandler("equip", this.commandEquip.bind(this));
    this._commandWindow.setHandler("optimize", this.commandOptimize.bind(this));
    this._commandWindow.setHandler("clear", this.commandClear.bind(this));
    this._commandWindow.setHandler("cancel", this.popScene.bind(this));
    this._commandWindow.setHandler("pagedown", this.nextActor.bind(this));
    this._commandWindow.setHandler("pageup", this.previousActor.bind(this));
    this.addWindow(this._commandWindow);
};

Scene_Equip.prototype.commandWindowRect = function() {
    const wx = 483;//this.statusWidth();
    const wy = 228;//this.mainAreaTop();
    const ww = 446;//Graphics.boxWidth - this.statusWidth();
    const wh = this.calcWindowHeight(1, true);
    return new Rectangle(wx, wy, ww, wh);
};

Scene_Equip.prototype.slotWindowRect = function() {
    const commandWindowRect = this.commandWindowRect();
    const wx = 483;//this.statusWidth();
    const wy = 308;//commandWindowRect.y + commandWindowRect.height;
    const ww = 446;//Graphics.boxWidth - this.statusWidth();
    const wh = 168;//this.mainAreaHeight() - commandWindowRect.height;
    return new Rectangle(wx, wy, ww, wh);
};



Scene_Equip.prototype.helpWindowRect = function() {
    const wx = 167;
    const wy = 471;//this.mainAreaTop();
    const ww = 762;//Graphics.boxWidth;
    const wh = 102;//this.calcWindowHeight(1, false);
    return new Rectangle(wx, wy, ww, wh);
};

})();